{
|
| KCPPas 1.0
|
| Copyleft (c) Alexandre Erwin Ittner - 2000
| kernel32@bigfoot.com  - http://kernel32.cjb.net
|
| Este programa e' um software de livre distribuicao 
| que pode ser copiado e distribuido conforme a 
| General Public License (GPL) versao 2 ou posterior, 
| conforme especificado pela Free Software Foundation.
|
}

program KCPPas;
uses
	crt;
var
	porta:integer;

procedure limpatela;
begin
	textbackground(1);
	clrscr;
end;

procedure mostratitulo;
begin
	gotoxy(1,1);
	textbackground(7);
	textcolor(0);
	write(' KCPPas 1.0 - Copyleft (c) Alexandre Erwin Ittner - 2000                        ');
	gotoxy(1,2);
	textbackground(1);
	textcolor(7);
	gotoxy(1,23);
end;

procedure prepara23; 
begin
	textbackground(1);
	textcolor(7);
	gotoxy(1,23);
	write('                                                                               ');
	gotoxy(1,23);
	mostratitulo;
end;

procedure saida(dados:integer);
begin
	asm
		Mov ax,dados
		Mov dx,porta
		Out dx,ax
	end;

end;

procedure alterar;
var
	dados:integer;
begin

	prepara23;
	write(' Dados em ', porta , ': ');
	read(dados);
	if dados <= 255 then
		begin
			saida(dados);
		end
	else
		begin
			prepara23;
			writeln(' ERRO: O mximo valor admissvel  255');
		end;
end;

procedure ler;
var
	dados:integer;
	dadoslidos:word;
begin
	prepara23;
	asm
		Mov dx,porta
		In ax,dx
		Mov dadoslidos,ax
	end;
	dados := Byte(dadoslidos); 
	writeln(' Dados em ', porta , ': ', dados);
end;

procedure testar;
const
	delaypadrao = 200;
var
	i,b,dados:integer;
begin
	prepara23;
	writeln(' Testando LEDs. Verifique a sada.');
	for i := 1 to 5 do
		begin
		saida(255);		{ 11111111b }
		delay(delaypadrao);
		saida(0);		{ 00000000b }
		delay(delaypadrao);
	end;
	for i := 1 to 5 do
	begin
		saida(85);		{ 01010101b }
		delay(delaypadrao);
		saida(170);		{ 10101010b }
		delay(delaypadrao);
	end;
	for i := 1 to 5 do
	begin
		b := 0;
		dados := 1;
		for b := 0 to 8 do
			begin
			saida(dados);
			dados := dados * 2;
			delay(delaypadrao);
		end;
	end;
	prepara23;
end;

procedure alterarporta;
begin
	prepara23;
	write(' Endereo da nova porta, em decimal (atual ', porta, '): ');
	read(porta);
	prepara23;
	write(' Nova porta: ',porta);
end;

procedure mostramenu;
var
	opcao:char;
label
	fim;
begin
	textbackground(7);
	gotoxy(1,25);

	{  a dificil arte de se construir um menuzinho colorido :-/  }
	textcolor(4);
	write('  A');
	textcolor(0);
	write('lterar dados  | ');
	textcolor(4);
	write('  L');
	textcolor(0);
	write('er dados  | ');
	textcolor(4);
	write('  T');
	textcolor(0);
	write('estar LEDs  | ');
	textcolor(0);
	write('  Alterar  ');
	textcolor(4);
	write('P');
	textcolor(0);
	write('orta   | ');
	textcolor(4);
	write(' S');
	textcolor(0);
	write('air  ');

	gotoxy(80,25);
        opcao := readkey;
        opcao := upcase(opcao);
        case opcao of
             'A':alterar;
             'L':ler;
             'T':testar;
             'P':alterarporta;
             'S':goto fim;
	end;
	textbackground(1);
	textcolor(7);
	mostratitulo;
	mostramenu;
	fim:
	textcolor(7);
	textbackground(0);
	clrscr;
end;

begin
	porta := 888;
	limpatela;
	mostratitulo;
	mostramenu;
end.
